// Copyright 2006 Nokia Corporation.
//
// THIS SOURCE CODE IS PROVIDED 'AS IS', WITH NO WARRANTIES WHATSOEVER,
// EXPRESS OR IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY, FITNESS
// FOR ANY PARTICULAR PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE
// OR TRADE PRACTICE, RELATING TO THE SOURCE CODE OR ANY WARRANTY OTHERWISE
// ARISING OUT OF ANY PROPOSAL, SPECIFICATION, OR SAMPLE AND WITH NO
// OBLIGATION OF NOKIA TO PROVIDE THE LICENSEE WITH ANY MAINTENANCE OR
// SUPPORT. FURTHERMORE, NOKIA MAKES NO WARRANTY THAT EXERCISE OF THE
// RIGHTS GRANTED HEREUNDER DOES NOT INFRINGE OR MAY NOT CAUSE INFRINGEMENT
// OF ANY PATENT OR OTHER INTELLECTUAL PROPERTY RIGHTS OWNED OR CONTROLLED
// BY THIRD PARTIES
//
// Furthermore, information provided in this source code is preliminary,
// and may be changed substantially prior to final release. Nokia Corporation
// retains the right to make changes to this source code at
// any time, without notice. This source code is provided for informational
// purposes only.
//
// Nokia and Nokia Connecting People are registered trademarks of Nokia
// Corporation.
// Java and all Java-based marks are trademarks or registered trademarks of
// Sun Microsystems, Inc.
// Other product and company names mentioned herein may be trademarks or
// trade names of their respective owners.
//
// A non-exclusive, non-transferable, worldwide, limited license is hereby
// granted to the Licensee to download, print, reproduce and modify the
// source code. The licensee has the right to market, sell, distribute and
// make available the source code in original or modified form only when
// incorporated into the programs developed by the Licensee. No other
// license, express or implied, by estoppel or otherwise, to any other
// intellectual property rights is granted herein.
package bcexchanger.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Gauge;
import javax.microedition.lcdui.Item;
import bcexchanger.*;

/**
 * 
 * This class implements the screen which indicates that some
 * operation is in progress. For example when inquiry, service
 * discovery, business card sending and receiving is running this
 * screen is displayed. Using this screen user can cancel the processs
 * 
 * The class is extending an example.BCExchanger.ui.Screen class
 * 
 * @version 1.0 29.09.2005
 * @see example.BCExchanger.ui.Screen Design patterns: State
 */
public class ProgressScreen extends Screen {

  private Command cancelCommand;

  private Gauge gauge;
  private Form progressBar;
  
  /**
   * Constructor
   * 
   * @param _midlet -
   *          the parent class which keeps the current UI state
   * @param message -
   *          text message to be displayed
   */
  public ProgressScreen(BCExchangerMIDlet _midlet, String message) {
    super(_midlet);

    progressBar = new Form("Please wait");

    gauge = new Gauge(message, false, Gauge.INDEFINITE, Gauge.CONTINUOUS_RUNNING);
    gauge.setLayout(Item.LAYOUT_CENTER);
    gauge.setLayout(Item.LAYOUT_VCENTER);
    progressBar.append(gauge);
    
    cancelCommand = new Command("Cancel", Command.CANCEL, 1);
    progressBar.addCommand(cancelCommand);

    progressBar.setCommandListener(this);
   
    displayable = progressBar;
    
  }

  public void commandAction(Command command, Displayable _displayable) {

    if (_displayable != progressBar) {
      // wrong displayable
      throw new RuntimeException("Internal error #21");
    }

    if (command == cancelCommand) {
      midlet.getExchanger().cancelSending();
    } else {
      // unknown command
      throw new RuntimeException("Internal error #22");
    }
  }

}
